// config: norepeat

#include "GetObjects.js"

var g_factories = null;

function MakePlane( bbox, frame, width, height )
{
	var factory = moi.command.createFactory( 'planecenter' );

	var margin = moi.ui.commandUI.margin.value;
	width += margin * 2.0;
	height += margin * 2.0;

	frame.origin = bbox.center;
	factory.setInput( 0, frame );
	factory.setInput( 2, width );
	factory.setInput( 3, height );
	factory.update();
	
	g_factories.push( factory );
}

function Update( bbox )
{
	if ( g_factories )
	{
		for ( var i = 0; i < g_factories.length; ++i )
			g_factories[i].cancel();
	}

	g_factories = new Array();

	if ( moi.ui.commandUI.make_xy.value )
		MakePlane( bbox, moi.vectorMath.createTopFrame(), bbox.xLength, bbox.yLength );

	if ( moi.ui.commandUI.make_xz.value )
		MakePlane( bbox, moi.vectorMath.createFrontFrame(), bbox.xLength, bbox.zLength );

	if ( moi.ui.commandUI.make_yz.value )
		MakePlane( bbox, moi.vectorMath.createRightFrame(), bbox.yLength, bbox.zLength );
}

function DoDividingPlanes()
{
	var objectpicker = moi.ui.createObjectPicker();
	if ( !GetObjects( objectpicker ) )
		return;

	var objects = objectpicker.objects;

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.showUI( 'Options' );
	moi.ui.showUI( 'OptionsPrompt' );
	moi.ui.endUIUPdate();

	var bbox = objects.getHighAccuracyBoundingBox();
	Update( bbox );


	var commandDialog = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !commandDialog.waitForEvent() )
			return false;

		var e = commandDialog.event;
		if ( e == 'done' )
			break;

		if ( e == 'make_xy' || e == 'make_xz' || e == 'make_yz' || e == 'margin' )
			Update( bbox );
	}

	if ( g_factories )
	{
		for ( var i = 0; i < g_factories.length; ++i )
			g_factories[i].commit();
	}
}

DoDividingPlanes();
